bug-coreutils
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

Re: Should "df --portability" allow thousands separators?


From: Jim Meyering
Subject: Re: Should "df --portability" allow thousands separators?
Date: Tue, 27 Feb 2007 19:38:44 +0100

Paul Eggert <address@hidden> wrote:
> "Peter D." <address@hidden> writes:
>
>> When an inconsistent set of environment variables and command
>> line options is given then sending a polite informative version
>> of "programming error" to standard error is useful.  However,
>> sending most sensible output to standard out will cause the
>> least grief.
>
> I also would prefer avoiding a diagnostic if possible.  Also, it
> seems confusing to pay attention to part of an environment variable,
> but ignore the rest.
>
> How about using the following rule instead?
>
>    If -P is used, ignore the DF_BLOCK_SIZE, BLOCK_SIZE, and BLOCKSIZE
>    environment variables.
>
> This is easier to document and understand (at least for me....).
>
> Here's a proposed patch to do that.

Thanks.
That's fine with me.  I've committed it.
Choosing between a complete patch and an off-the-cuff one is always easy :)

But we still need a test case or two for this, so I've added one:

diff --git a/ChangeLog b/ChangeLog
index 0175406..56580a0 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -5,6 +5,12 @@
        affected by DF_BLOCK_SIZE, BLOCK_SIZE, or BLOCKSIZE.
        * src/df.c (main): Implement this.

+2007-02-27  Jim Meyering  <address@hidden>
+
+       Add a test for the above.
+       * tests/misc/df-P: New file.
+       * tests/misc/Makefile.am (TESTS): Add df-P.
+
 2007-02-25  Jim Meyering  <address@hidden>

        * Makefile.maint (announcement): Adjust so that it works with
diff --git a/tests/misc/Makefile.am b/tests/misc/Makefile.am
index 4372850..5ecd451 100644
--- a/tests/misc/Makefile.am
+++ b/tests/misc/Makefile.am
@@ -39,6 +39,7 @@ TESTS_ENVIRONMENT = \
 # will execute the test script rather than the standard utility.

 TESTS = \
+  df-P \
   pwd-unreadable-parent \
   cut \
   wc-files0-from \
diff --git a/tests/misc/df-P b/tests/misc/df-P
new file mode 100644
index 0000000..3a5ec9b
--- /dev/null
+++ b/tests/misc/df-P
@@ -0,0 +1,60 @@
+#!/bin/sh
+# Ensure that df -P is not affected by BLOCK_SIZE settings
+
+# Copyright (C) 2007 Free Software Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+  set -x
+  df --version
+fi
+
+. $srcdir/../envvar-check
+. $srcdir/../lang-default
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd "$pwd" && chmod -R u+rwx $t0 && rm -rf $t0 && exit 
$status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+
+if test $framework_failure = 1; then
+  echo "$0: failure in testing framework" 1>&2
+  (exit 1); exit 1
+fi
+
+fail=0
+
+              df -P . > t1 || fail=1
+BLOCK_SIZE=1M df -P . > t2 || fail=1
+
+# Since disk utilization may be changing, compare only df's header line.
+# That records the block size.  E.g., for "1M", it would be:
+# Filesystem         1048576-blocks      Used Available Capacity Mounted on
+# while for 1K, it would be
+# Filesystem         1024-blocks      Used Available Capacity Mounted on
+
+head -n1 t1 > exp || fail=1
+head -n1 t2 > out || fail=1
+
+cmp out exp || fail=1
+test $fail = 1 && diff out exp 2> /dev/null
+
+(exit $fail); exit $fail




reply via email to

[Prev in Thread] Current Thread [Next in Thread]